/*******************************************************************************
;* File Name          : ADC_Work.C
;* Author             : GRAND LOTUS
;* Version            : V1.00
;* Date               : 2019/07/01
;******************************************************************************
;
;ADC采集数据处理程序
;
;*******************************************************************************/
#include"common.h"
unsigned	int	ADC_Temp;
unsigned  	int	ADC_MAX_DATA;
unsigned  	int	ADC_MIN_DATA;
unsigned  	int	ADC_DATA_Sum;



//*************************************************************************
//ADC转换数据，将ADH向左移8位再加上ADL可以构成12位数据
//*************************************************************************
void  ADCSampling12Bit(uchar Num)
{  
	ADCON0 = ADCON0 & 0xF0;
	ADCON0 = ADCON0 | Num;
	ADS=1;						//启动ADC转换
	while(ADS==1);				//等待转换结束
	ADS=1;						//启动ADC转换
	while(ADS==1);				//等待转换结束
	ADS=1;						//启动ADC转换
	while(ADS==1);				//等待转换结束
	ADC_Temp = ADH; 			//取第3次的数据
	ADC_Temp=ADC_Temp<<8;	//将ADH向左移8位
	ADC_Temp=ADC_Temp+ADL;	//将R_ADC_DATA=ADH+ADL
}



//*************************************************************************
//ADC测量数据处理程序
//说明:取十次ADC转换的值，将最大值和最小值去除之后，再求出平均值得到的值
//*************************************************************************
void  ADC_DATA_Deal(void)
{  	
	uchar	i;
	ADC_MIN_DATA = 0xFFFF;				//最小值赋值
	ADC_MAX_DATA = 0x0000;				//最大值赋值
	ADC_DATA_Sum = 0x0000;
	for(i=0;i<10;i++)
	{   
		ADCSampling12Bit(0x01);
		ADC_DATA_Sum = ADC_DATA_Sum+ADC_Temp; 	 //累加ADC测量数据		
		if(ADC_Temp>ADC_MAX_DATA)	//判断最大值
		{
			ADC_MAX_DATA=ADC_Temp;		
		}		
		if(ADC_Temp<ADC_MIN_DATA)	//判断最小值	
		{
			ADC_MIN_DATA=ADC_Temp;
		}		
	}
	ADC_DATA_Sum=ADC_DATA_Sum-ADC_MAX_DATA-ADC_MIN_DATA;
	ADC_DATA_Sum=ADC_DATA_Sum>>3;			//剩下8组数据平均	
	//测量ADC通道的最后结果放在ADC_DATA_SUM_H,ADC_DATA_SUM_L
}

/*********************************END OF FILE************************************/ 