;*******************(C) COPYRIGHT 2019 GRAND-LOTUS ****************************************** 
;* File Name          : PWM1_INIT.INC
;* Author             : GRAND LOTUS
;* Version            : V1.00
;* Date               : 2019/07/01
;********************************************************************************************
;
;PWM1初始化程序
;
;********************************************************************************************

;//******************************************************************************************
;/////////////////////T0CR 控制寄存器各位定义////////////////////////////////////////////////
;//******************************************************************************************
;//TxCR 定时器控制寄存器
;//TCxEN:  TCx模块使能位
;//1 = 使能TCx
;//0 = 关闭TCx
;//TCxMOD:  TCx模式选择位
;//1 = 16位模式
;//0 = 8位模式
;//TCxCKS:  TCx时钟源选择
;//TCxCKS[1:0]	TCx时钟源选择
;//00	Foscl(低频系统时钟)
;//01	Fosch(高频系统时钟)
;//10	Fcpu
;//11	TC0:(T0cki) TC1:(TK)
;//TCxCKPS[2:0]:  TCx预分频比选择
;//TCxCKPS[2:0]	TCx预分频比
;//000	1:1
;//001	1:2
;//010	1:4
;//011	1:8
;//100	1:16
;//101	1:32
;//110	1:64
;//111	1:128
#define		TC0EN_1					b'10000000'				;//使能TC0			
#define   	TC0EN_0     			b'00000000'				;//屏蔽TC0
#define	  	TC0MOD_16				b'01000000'				;//16位模式
#define	  	TC0MOD_8				b'00000000'				;//8位模式
#define		TC0CKS_Foscl			b'00000000'				;//Foscl(低频系统时钟)
#define		TC0CKS_Fosch			b'00001000'				;//Fosch(高频系统时钟)
#define		TC0CKS_Fcpu				b'00010000'				;//Fcpu
#define		TC0CKPS_1_1				b'00000000'				;//分频比1：1
#define		TC0CKPS_1_2				b'00000001'				;//分频比1：2
#define		TC0CKPS_1_4				b'00000010'				;//分频比1：4
#define		TC0CKPS_1_8				b'00000011'				;//分频比1：8
#define		TC0CKPS_1_16			b'00000100'				;//分频比1：16
#define		TC0CKPS_1_32			b'00000101'				;//分频比1：32
#define		TC0CKPS_1_64			b'00000110'				;//分频比1：64
#define		TC0CKPS_1_128			b'00000111'				;//分频比1：128
;******************************************************************************************************
;///////////////////// PWM1CR控制寄存器各位定义////////////////////////////////////////////////////////
;******************************************************************************************************
;//Bit 7 		PWM1EN:  PWM模块使能位
;//1 = 使能PWM
;//0 = 关闭PWM
;//Bit 6 		PWM1POE:  PWM正相波形输出使能位
;//1 = 端口输出PWM1P波形
;//0 = 端口用作IO
;//Bit 5 		PWM1NOE:  PWM反相波形输出使能位
;//1 = 端口输出PWM1N波形
;//0 = 端口用作IO
;//Bit 4 		PWM1PAS:  PWM1P波形有效电平选择
;//1 = PWM1P波形有效电平为低电平
;//0 = PWM1P波形有效电平为高电平
;//Bit 3 		PWM1NAS:  PWM1N波形有效电平选择
;//1 = PWM1N波形有效电平为高电平
;//0 = PWM1N波形有效电平为低电平
;//Bit 2 		PWM1TBS:  时基选择
;//1 = 定时器1
;//0 = 定时器0
;//Bit [1:0]		PWM1S[1:0]:  PWM输出端口选择
;//PWM1S[1:0]	PWM输出端口
;//00	PWM1P/PWM1N
;//01	PWM1PX/PWM1NX
;//10	PWM1PY/PWM1NY
;//11		保留
#define		PWM1EN_1				b'10000000'						;//使能PWM
#define   	PWM1EN_0     			b'00000000'						;//关闭PWM
#define		PWM1POE_1				b'01000000'						;//端口输出PWM1P波形
#define		PWM1POE_0				b'00000000'						;//端口用作IO
#define		PWM1NOE_1				b'00100000'						;//端口输出PWM1N波形
#define		PWM1NOE_0				b'00000000'						;//端口用作IO
#define		PWM1PAS_1				b'00010000'						;//PWM1P波形有效电平为低电平
#define		PWM1PAS_0				b'00000000'						;//PWM1P波形有效电平为高电平
#define		PWM1NAS_1				b'00001000'						;//PWM1N波形有效电平为高电平
#define		PWM1NAS_0				b'00000000'						;//PWM1N波形有效电平为低电平
#define		PWM1TBS_1				b'00000100'						;//时基选择定时器1
#define		PWM1TBS_0				b'00000000'						;//时基选择定时器0
#define		PWM1S_00				b'00000000'						;//PWM输出波形端口PWM1P/PWM1N
#define		PWM1S_01				b'00000001'						;//PWM输出波形端口PWM1PX/PWM1NX
#define		PWM1S_10				b'00000010'						;//PWM输出波形端口PWM1PY/PWM1NY
#define		PWM1S_11				b'00000011'						;//PWM输出波形端口保留
;******************************************************************************************************
;/////////////////////////////////////PWMDEADT控制寄存器各位定义///////////////////////////////////////
;******************************************************************************************************
;//Bit[7:4]DEADTF[3:0]:  前死区宽度设置
#define		DEADTF_0000				b'00000000'						;//无前死区
#define		DEADTF_0001				b'00010000'						;//前死区时间为1*(时基时钟周期/2)
#define		DEADTF_0011				b'00110000'						;//前死区时间为2*(时基时钟周期/2)
#define		DEADTF_0010				b'00100000'						;//前死区时间为3*(时基时钟周期/2)
#define		DEADTF_1010				b'10100000'						;//前死区时间为4*(时基时钟周期/2)
#define		DEADTF_1011				b'10110000'						;//前死区时间为5*(时基时钟周期/2)
#define		DEADTF_1001				b'10010000'						;//前死区时间为6*(时基时钟周期/2)
#define		DEADTF_1101				b'11010000'						;//前死区时间为7*(时基时钟周期/2)
#define		DEADTF_0101				b'01010000'						;//前死区时间为8*(时基时钟周期/2)
#define		DEADTF_0100				b'01000000'						;//前死区时间为9*(时基时钟周期/2)
#define		DEADTF_0110				b'01100000'						;//前死区时间为10*(时基时钟周期/2)
#define		DEADTF_0111				b'01110000'						;//前死区时间为11*(时基时钟周期/2)
#define		DEADTF_1111				b'11110000'						;//前死区时间为12*(时基时钟周期/2)
#define		DEADTF_1110				b'11100000'						;//前死区时间为13*(时基时钟周期/2)
#define		DEADTF_1100				b'11000000'						;//前死区时间为14*(时基时钟周期/2)
#define		DEADTF_1000				b'10000000'						;//前死区时间为15*(时基时钟周期/2)
;//Bit[3:0]DEADTR[3:0]:  后死区宽度设置
#define		DEADTR_0000				b'00000000'						;//无后死区
#define		DEADTR_0001				b'00000001'						;//后死区时间为1*(时基时钟周期/2)
#define		DEADTR_0011				b'00000011'						;//后死区时间为2*(时基时钟周期/2)
#define		DEADTR_0010				b'00000010'						;//后死区时间为3*(时基时钟周期/2)
#define		DEADTR_1010				b'00001010'						;//后死区时间为4*(时基时钟周期/2)
#define		DEADTR_1011				b'00001011'						;//后死区时间为5*(时基时钟周期/2)
#define		DEADTR_1001				b'00001001'						;//后死区时间为6*(时基时钟周期/2)
#define		DEADTR_1101				b'00001101'						;//后死区时间为7*(时基时钟周期/2)
#define		DEADTR_0101				b'00000101'						;//后死区时间为8*(时基时钟周期/2)
#define		DEADTR_0100				b'00000100'						;//后死区时间为9*(时基时钟周期/2)
#define		DEADTR_0110				b'00000110'						;//后死区时间为10*(时基时钟周期/2)
#define		DEADTR_0111				b'00000111'						;//后死区时间为11*(时基时钟周期/2)
#define		DEADTR_1111				b'00001111'						;//后死区时间为12*(时基时钟周期/2)
#define		DEADTR_1110				b'00001110'						;//后死区时间为13*(时基时钟周期/2)
#define		DEADTR_1100				b'00001100'						;//后死区时间为14*(时基时钟周期/2)
#define		DEADTR_1000				b'00001000'						;//后死区时间为15*(时基时钟周期/2)

;******************************************************************************************************
;===========================================PWM1波形===================================================
;******************************************************************************************************
PWM1_Init:
;//1、IO端口设置
	BSET		OEB,3													;//PWM1N波形输出口
	BSET		OEB,4													;//PWM1P波形输出口
;//2、时钟源设置(以TC0为例,使其产生1KHz的波形)
	MOVIA		TC0MOD_8+TC0CKS_Fosch+TC0CKPS_1_64																
	MOVAR		T0CR													;//定时器T0，8位Fosch，频分比1：1
	CLRR		TC0CH
	MOVIA		249
	MOVAR		TC0CL													;//16MHz/64/(249+1)=1KHz，产生波形为1K															
;//3、PWM设置
	MOVIA		PWM1POE_1+PWM1NOE_1+PWM1PAS_1+PWM1NAS_1+PWM1TBS_0+PWM1S_00											
	MOVAR		PWM1CR													;//PWM时基选择定时器T0,端口输出PWM1P低电平有效,PWM1N高电平有效波形
	MOVIA		0x00
	MOVAR		PWM1DL													;//8+4位分辨率模式
	MOVIA		(249+1)/2
	MOVAR		PWM1DH													;//占空比为1：1						
	MOVIA		DEADTF_0000+DEADTR_0000									;//死去宽度设置
	MOVAR		PWMDEADT											    ;//无前死区和后死区
;//4、开启PWM1	
	BSET 		T0CR,7												    ;//定时器T0开启
	BSET		PWM1CR,7												;//PWM1开启
	RETURN

;*********************************END OF FILE*******************************************************  
		