/*******************(C) COPYRIGHT 2019 GRAND-LOTUS ******************************************
;* File Name          : TC0_INIT.C
;* Author             : GRAND LOTUS
;* Version            : V1.00
;* Date               : 2019/07/01
*********************************************************************************************
;
;TIMER0定时1MS程序
;
********************************************************************************************/

#include "common.h"
//******************************************************************************************
////////////////////////////////T0CR 控制寄存器各位定义/////////////////////////////////////
//******************************************************************************************
//TxCR 定时器控制寄存器
//TCxEN:  TCx模块使能位
//1 = 使能TCx
//0 = 关闭TCx
//TCxMOD:  TCx模式选择位
//1 = 16位模式
//0 = 8位模式
//TCxCKS:  TCx时钟源选择
//TCxCKS[1:0]	TCx时钟源选择
//00	Foscl(低频系统时钟)
//01	Fosch(高频系统时钟)
//10	Fcpu
//11	TC0:(T0cki) TC1:(TK)
//TCxCKPS[2:0]:  TCx预分频比选择
//TCxCKPS[2:0]	TCx预分频比
//000	1:1
//001	1:2
//010	1:4
//011	1:8
//100	1:16
//101	1:32
//110	1:64
//111	1:128
#define		TC0EN_1				Bin(10000000)             	//使能TC0			
#define   	TC0EN_0     		Bin(00000000)				//屏蔽TC0
#define	  	TC0MOD_16			Bin(01000000)				//16位模式
#define	  	TC0MOD_8			Bin(00000000)				//8位模式
#define		TC0CKS_Foscl		Bin(00000000)				//Foscl(低频系统时钟)
#define		TC0CKS_Fosch		Bin(00001000)				//Fosch(高频系统时钟)
#define		TC0CKS_Fcpu			Bin(00010000)				//Fcpu
#define		TC0CKPS_1_1			Bin(00000000)				//分频比1：1
#define		TC0CKPS_1_2			Bin(00000001)				//分频比1：2
#define		TC0CKPS_1_4			Bin(00000010)				//分频比1：4
#define		TC0CKPS_1_8			Bin(00000011)				//分频比1：8
#define		TC0CKPS_1_16		Bin(00000100)				//分频比1：16
#define		TC0CKPS_1_32		Bin(00000101)				//分频比1：32
#define		TC0CKPS_1_64		Bin(00000110)				//分频比1：64
#define		TC0CKPS_1_128		Bin(00000111)				//分频比1：128
//******************************************************************************************
//********************************定时器T0定时1ms程序***************************************
//******************************************************************************************
void TC0_INIT(void)
{
//;//1、时钟源设置(以TC0为例,使其产生1ms的波形)
	T0CR =  (unsigned char ) ( TC0MOD_8 + TC0CKS_Fosch + TC0CKPS_1_128);	   	//8位，高频，频分比1:128
    TC0CH = 0;
    TC0CL = 124;															   	//16M/128/(124+1)=1ms 
//2、开启定时器TC0   
	TC0EN = 1;																	//使能TC0
//3、开启定时器TC0中断	
	TC0IF = 0;																	//清中断标志位
	TC0IE = 1;																	//开启定时器TC0溢出中断
	GIE  =  1;																	//1:总中断使能,0:屏蔽所有中断
}
/*********************************END OF FILE************************************/
